package fr.velossity.sample.device.impl;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import fr.velossity.sample.device.Device;

/**
 * 
 * @author C. Saint-Marcel
 * 
 */
public class Activator implements BundleActivator {

	/**
	 * @see BundleActivator#start(BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		// Service class name
		String clazz = Device.class.getName();
		
		// REQUESTS a service implementing a Device service of type Mock 
		ServiceReference sr[] = context.getAllServiceReferences(clazz, "(type=Mock)");
		if(sr != null && sr.length != 0) {
			
			// BINDS to the service provider
			Device myDevice = (Device) context.getService(sr[0]);
			
			// INVOKES the service
			System.out.println("I found a mock device with identifer= " + myDevice.getIdentifier());
		
		} else {
			System.out.println("I found no mock device at that time");
		}
	}

	/**
	 * @see BundleActivator#stop(BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}

}
